diff -ruN ccp4srs-old/ccp4srs/ccp4srs_monomer.cpp ccp4srs/ccp4srs/ccp4srs_monomer.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_monomer.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_monomer.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -22,674 +22,587 @@
 //
 //  =================================================================
 //
-//    17.04.12   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
-//  **** Module  :  ccp4srs_monomer  <interface>
+//  **** Module  :  ccp4srs_monomer  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSMonomer  - monomer structure
+//  **** Classes :  ccp4srs::Monomer  - monomer structure
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2012
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
 
-#ifndef  __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_monomer.h"
 #include "ccp4srs_defs.h"
 
-#include "mmdb/linalg_.h"
-#include "mmdb/mmdb_tables.h"
+#include "mmdb2/mmdb_math_linalg.h"
+#include "mmdb2/mmdb_tables.h"
 
+namespace ccp4srs  {
 
-CCP4SRSMonomer::CCP4SRSMonomer() : CCP4SRSEntry()  {
-  Init();
-}
-
-CCP4SRSMonomer::~CCP4SRSMonomer()  {
-  reset();
-}
-
-void CCP4SRSMonomer::Init()  {
-  monID   [0] = char(0);
-  oldMonID[0] = char(0);
-  monName     = NULL;
-  monType     = NULL;
-  monFormula  = NULL;
-}
-
-void CCP4SRSMonomer::reset()  {
-
-  atoms      .empty();
-  bonds      .empty();
-  angles     .empty();
-  torsions   .empty();
-  chicenters .empty();
-  planes     .empty();
-  struct_tree.empty();
-
-  if (monName)     delete[] monName;
-  if (monType)     delete[] monType;
-  if (monFormula)  delete[] monFormula;
-
-  Init();
-
-}
-
-void CCP4SRSMonomer::setOldID ( cpstr oldID )  {
-  strcpy ( oldMonID,oldID );
-}
-
-cpstr  CCP4SRSMonomer::chem_name()  {
-  if (monName)  return monName;
-  return "";
-}
-
-cpstr  CCP4SRSMonomer::chem_type()  {
-  if (monType)  return monType;
-  return "";
-}
-
-cpstr  CCP4SRSMonomer::chem_formula()  {
-  if (monFormula)  return monFormula;
-  return "";
-}
-
-void CCP4SRSMonomer::getLeavingAtoms ( int & nLeavingAtoms,
-                                       ivector & leavingAtom,
-                                       ivector & bondedAtom )  {
-//  should be called after all atoms and bonds are set up
-int i,j;
-
-  FreeVectorMemory ( leavingAtom,0 );
-  FreeVectorMemory ( bondedAtom ,0 );
-
-  nLeavingAtoms = 0;
-  for (i=0;i<atoms.numberOf();i++)
-    if (atom(i)->isLeaving())
-      nLeavingAtoms++;
-
-  if (nLeavingAtoms>0)  {
-    GetVectorMemory ( leavingAtom,nLeavingAtoms,0 );
-    GetVectorMemory ( bondedAtom ,nLeavingAtoms,0 );
-    j = 0;
-    for (i=0;i<atoms.numberOf();i++)
-      if (atom(i)->isLeaving())  {
-        leavingAtom[j] =  i;
-        bondedAtom [j] = -1;
-        j++;
-      }
-    for (i=0;i<nLeavingAtoms;i++)
-      for (j=0;j<bonds.numberOf();j++)  {
-        if ((leavingAtom[i]==bond(j)->atom1()) &&
-            (strcmp(atom(bond(j)->atom2())->element(),"H")))
-          bondedAtom[i] = bond(j)->atom2();
-        else if ((leavingAtom[i]==bond(j)->atom2()) &&
-            (strcmp(atom(bond(j)->atom1())->element(),"H")))
-          bondedAtom[i] = bond(j)->atom1();
-      }
+  Monomer::Monomer() : Entry()  {
+    Init();
   }
 
-}
-
-
-int  superpose_atoms ( mat44 & T, PPCCP4SRSAtom A1, PPCAtom A2,
-                       int nAtoms,
-                       rmatrix & A, rmatrix & U, rmatrix & V,
-                       rvector & W, rvector & RV1 )  {
-//   Given two sets of atoms, A1 and A2, superpose_atoms(...)
-// calculates the rotational-translational matrix T such that
-// |T*A1 - A2| is minimal in least-square terms. The transfomation
-// superposes exactly the atoms A1[0] and A2[0].
-realtype det,B;
-vect3    vc1,vc2;
-int      i,j,k;
+  Monomer::~Monomer()  {
+    reset();
+  }
 
-  //  1.  Calculate the correlation matrix. The rotation will be
-  //      done around
+  void Monomer::Init()  {
+    monID   [0] = char(0);
+    oldMonID[0] = char(0);
+    monName     = NULL;
+    monType     = NULL;
+    monFormula  = NULL;
+  }
 
-  for (i=1;i<=3;i++)
-    for (j=1;j<=3;j++)
-      A[i][j] = 0.0;
+  void Monomer::reset()  {
 
-  for (k=1;k<nAtoms;k++)  {
-    vc1[0] = A1[k]->x() - A1[0]->x();
-    vc1[1] = A1[k]->y() - A1[0]->y();
-    vc1[2] = A1[k]->z() - A1[0]->z();
-    vc2[0] = A2[k]->x - A2[0]->x;
-    vc2[1] = A2[k]->y - A2[0]->y;
-    vc2[2] = A2[k]->z - A2[0]->z;
-    for (i=1;i<=3;i++)
-      for (j=1;j<=3;j++)
-        A[i][j] += vc1[j-1]*vc2[i-1];
-  }
+    atoms      .empty();
+    bonds      .empty();
+    angles     .empty();
+    torsions   .empty();
+    chicenters .empty();
+    planes     .empty();
+    struct_tree.empty();
 
-  //  2. Calculate transformation matrix (to be applied to A1)
+    if (monName)     delete[] monName;
+    if (monType)     delete[] monType;
+    if (monFormula)  delete[] monFormula;
 
-  det = A[1][1]*A[2][2]*A[3][3] +
-        A[1][2]*A[2][3]*A[3][1] +
-        A[2][1]*A[3][2]*A[1][3] -
-        A[1][3]*A[2][2]*A[3][1] -
-        A[1][1]*A[2][3]*A[3][2] -
-        A[3][3]*A[1][2]*A[2][1];
+    Init();
 
-  //  2.1 SV-decompose the correlation matrix
+  }
 
-  SVD ( 3,3,3,A,U,V,W,RV1,True,True,i );
+  void Monomer::setOldID ( mmdb::cpstr oldID )  {
+    strcpy ( oldMonID,oldID );
+  }
 
-  if (i!=0)  return CCP4SRS_SVD_Fail;
+  mmdb::cpstr  Monomer::chem_name()  {
+    if (monName)  return monName;
+    return "";
+  }
 
-  //  2.2 Check for parasite inversion and fix it if found
+  mmdb::cpstr  Monomer::chem_type()  {
+    if (monType)  return monType;
+    return "";
+  }
 
-  if (det<=0.0)  {
-    k = 0;
-    B = MaxReal;
-    for (j=1;j<=3;j++)
-      if (W[j]<B)  {
-        B = W[j];
-        k = j;
-      }
-    for (j=1;j<=3;j++)
-      V[j][k] = -V[j][k];
+  mmdb::cpstr  Monomer::chem_formula()  {
+    if (monFormula)  return monFormula;
+    return "";
   }
 
-  //  2.3 Calculate rotational part of T
+  void Monomer::getLeavingAtoms ( int & nLeavingAtoms,
+                                         mmdb::ivector & leavingAtom,
+                                         mmdb::ivector & bondedAtom )  {
+  //  should be called after all atoms and bonds are set up
+  int i,j;
 
-  for (j=1;j<=3;j++)
-    for (k=1;k<=3;k++)  {
-      B = 0.0;
-      for (i=1;i<=3;i++)
-        B += U[j][i]*V[k][i];
-      T[j-1][k-1] = B;
-    }
+    mmdb::FreeVectorMemory ( leavingAtom,0 );
+    mmdb::FreeVectorMemory ( bondedAtom ,0 );
 
-  //  2.4 Add translational part to T
+    nLeavingAtoms = 0;
+    for (i=0;i<atoms.numberOf();i++)
+      if (atom(i)->isLeaving())
+        nLeavingAtoms++;
 
-  T[0][3] = A2[0]->x - T[0][0]*A1[0]->x() - T[0][1]*A1[0]->y() -
-                       T[0][2]*A1[0]->z();
-  T[1][3] = A2[0]->y - T[1][0]*A1[0]->x() - T[1][1]*A1[0]->y() -
-                       T[1][2]*A1[0]->z();
-  T[2][3] = A2[0]->z - T[2][0]*A1[0]->x() - T[2][1]*A1[0]->y() -
-                       T[2][2]*A1[0]->z();
-
-  return CCP4SRS_Ok;
-
-}
-
-int CCP4SRSMonomer::atom_no ( cpstr aname )  {
-// returns number of atom with given name [0...], or -1 if atom
-// is not found
-int i,n;
-
-  n = -1;
-  for (i=0;(i<atoms.numberOf()) && (n<0);i++)
-    if (!strcmp(atoms.at(i)->name(),aname))
-      n = i;
-
-  return n;
-
-}
-
-int CCP4SRSMonomer::get_bound ( int atomNo, cpstr elem, int serNo ) {
-// returns number of atom with chemical element 'elem', bound to
-// atom number 'atomNo' [0,1,..]. serNo==0 returns 1st atom found,
-// serNo==1 returns second atom and so on. If atom not found, -1 is
-// returned.
-int i,j,n, atm1,atm2;
-
-  n = -1;
-  j = 0;
-  for (i=0;(i<bonds.numberOf()) && (n<0);i++)  {
-    atm2 = bonds.at(i)->atom2();
-    if (atm2==atomNo)  {
-      atm1 = atm2;
-      atm2 = bonds.at(i)->atom1();
-    } else
-      atm1 = bonds.at(i)->atom1();
-    if (atm1==atomNo)  {
-      if (!strcmp(atoms.at(atm2)->element(),elem))  {
-        if (j==serNo)  n = atm2;
-                 else  j++;
-      }
+    if (nLeavingAtoms>0)  {
+      mmdb::GetVectorMemory ( leavingAtom,nLeavingAtoms,0 );
+      mmdb::GetVectorMemory ( bondedAtom ,nLeavingAtoms,0 );
+      j = 0;
+      for (i=0;i<atoms.numberOf();i++)
+        if (atom(i)->isLeaving())  {
+          leavingAtom[j] =  i;
+          bondedAtom [j] = -1;
+          j++;
+        }
+      for (i=0;i<nLeavingAtoms;i++)
+        for (j=0;j<bonds.numberOf();j++)  {
+          if ((leavingAtom[i]==bond(j)->atom1()) &&
+              (strcmp(atom(bond(j)->atom2())->element(),"H")))
+            bondedAtom[i] = bond(j)->atom2();
+          else if ((leavingAtom[i]==bond(j)->atom2()) &&
+              (strcmp(atom(bond(j)->atom1())->element(),"H")))
+            bondedAtom[i] = bond(j)->atom1();
+        }
     }
+
   }
 
-  return n;
 
-}
+  int  superpose_atoms ( mmdb::mat44 & T, PPAtom A1,
+                  mmdb::PPAtom A2, int nAtoms,
+                  mmdb::rmatrix & A, mmdb::rmatrix & U, mmdb::rmatrix & V,
+                  mmdb::rvector & W, mmdb::rvector & RV1 )  {
+  //   Given two sets of atoms, A1 and A2, superpose_atoms(...)
+  // calculates the rotational-translational matrix T such that
+  // |T*A1 - A2| is minimal in least-square terms. The transfomation
+  // superposes exactly the atoms A1[0] and A2[0].
+  mmdb::realtype det,B;
+  mmdb::vect3    vc1,vc2;
+  int            i,j,k;
 
-int CCP4SRSMonomer::get_bound ( int atomNo, int n ) {
-// returns nth [0,1,..] atom bound to atom with name 'aname'
-int  i,j,k,atm1,atm2;
+    //  1.  Calculate the correlation matrix. The rotation will be
+    //      done around
 
-  k = -1;
-  j = 0;
-  for (i=0;(i<bonds.numberOf()) && (k<0);i++)  {
-    atm1 = bonds.at(i)->atom1();
-    atm2 = bonds.at(i)->atom2();
-    if (atm1==atomNo)  {
-      if (j==n) k = atm2;
-           else j++;
-    } else if (atm2==atomNo)  {
-      if (j==n) k = atm1;
-           else j++;
-    }
-  }
+    for (i=1;i<=3;i++)
+      for (j=1;j<=3;j++)
+        A[i][j] = 0.0;
 
-  return k;
+    for (k=1;k<nAtoms;k++)  {
+      vc1[0] = A1[k]->x() - A1[0]->x();
+      vc1[1] = A1[k]->y() - A1[0]->y();
+      vc1[2] = A1[k]->z() - A1[0]->z();
+      vc2[0] = A2[k]->x - A2[0]->x;
+      vc2[1] = A2[k]->y - A2[0]->y;
+      vc2[2] = A2[k]->z - A2[0]->z;
+      for (i=1;i<=3;i++)
+        for (j=1;j<=3;j++)
+          A[i][j] += vc1[j-1]*vc2[i-1];
+    }
 
-}
+    //  2. Calculate transformation matrix (to be applied to A1)
 
-int CCP4SRSMonomer::get_bound ( cpstr aname, int n ) {
-// returns nth [0,1,..] atom bound to atom with name 'aname'
-int  i,j,k,atm1,atm2;
+    det = A[1][1]*A[2][2]*A[3][3] +
+          A[1][2]*A[2][3]*A[3][1] +
+          A[2][1]*A[3][2]*A[1][3] -
+          A[1][3]*A[2][2]*A[3][1] -
+          A[1][1]*A[2][3]*A[3][2] -
+          A[3][3]*A[1][2]*A[2][1];
 
-  k = -1;
-  j = 0;
-  for (i=0;(i<bonds.numberOf()) && (k<0);i++)  {
-    atm1 = bonds.at(i)->atom1();
-    atm2 = bonds.at(i)->atom2();
-    if (!strcmp(atoms.at(atm1)->name(),aname))  {
-      if (j==n) k = atm2;
-           else j++;
-    } else if (!strcmp(atoms.at(atm2)->name(),aname))  {
-      if (j==n) k = atm1;
-           else j++;
-    }
-  }
+    //  2.1 SV-decompose the correlation matrix
 
-  return k;
+    mmdb::math::SVD ( 3,3,3,A,U,V,W,RV1,true,true,i );
 
-}
+    if (i!=0)  return CCP4SRS_SVD_Fail;
 
+    //  2.2 Check for parasite inversion and fix it if found
 
-int CCP4SRSMonomer::addHydrogens ( PCResidue R )  {
-//
-//   Return:
-//     CCP4SRS_Ok             success
-//     CCP4SRS_EmptyResidue   residue R does not contain atoms
-//     CCP4SRS_NoAtomsFound   monomer does not contain atoms
-//     CCP4SRS_NoBonds        monomer does not contain bonds
-//     CCP4SRS_NoAtomsData    monomer is not complete
-//     CCP4SRS_NoSimilarity   too few coomon atom names in R and SRS
-//                            entry with the same structure name
-//     CCP4SRS_SuperpositionFailed  failed residue superposition
-//
-// NOTE1: the function does not rearranges existing atoms in the
-// residue, but places the hydrogens on top of them (leaving the
-// Ter pseudoatom, if found, on top of the list).
-//
-// NOTE2: in case of alternative locations, the first one in the
-// residue is chosen.
-//
-PPCAtom      H;
-PCCP4SRSAtom sa1[10];
-PCCP4SRSAtom atomi;
-PCAtom       sa2[10];
-AtomName     aname;
-rmatrix      D,U,V;
-rvector      W,RV1;
-imatrix      c;
-ivector      A,nb;
-mat44        T;
-int          natoms,nbonds, i,j,k,m,n,mm,nTer,nH;
-
-
-  //  1.  Make simple checks first
-
-  natoms = atoms.numberOf();
-  nbonds = bonds.numberOf();
-
-  if (natoms<=2)          return CCP4SRS_NoAtomsFound;
-  if (nbonds<=0)          return CCP4SRS_NoBonds;
-  if (R->nAtoms<=2)       return CCP4SRS_EmptyResidue;
-  if (natoms==R->nAtoms)  return CCP4SRS_Ok;
-
-
-  //  2.  Map existing atoms from the residue onto a local array
-
-  GetVectorMemory ( A,natoms,0 );
-  nTer = 20000;
-  for (i=0;i<natoms;i++)  {
-    A[i] = -1;  // signal "no atom"
-    for (j=0;(j<R->nAtoms) && (A[i]<0);j++)
-      if (R->atom[j])  {
-        if (R->atom[j]->Ter)
-          nTer = j;
-        else if (!strcmp(atoms.at(i)->name_pdb(aname),R->atom[j]->name))
-          A[i] = j;  // here is the place to check for altlocs
-      }
-  }
-
-
-  //  3.  Make bond matrix
-
-  GetMatrixMemory ( c ,natoms,10,0,0 );
-  GetVectorMemory ( nb,natoms,0 );
-
-  for (i=0;i<natoms;i++)
-    nb[i] = 0;  // number of bonds at ith atom
-
-  for (i=0;i<nbonds;i++)  {
-    j = bonds.at(i)->atom1();
-    k = bonds.at(i)->atom2();
-    c[j][nb[j]] = k;
-    c[k][nb[k]] = j;
-    nb[j]++;
-    nb[k]++;
-  }
-
-
-  //  4.  Loop over all hydrogens. Locate core atoms bonded to
-  //      hydrogen in SBStructure and superpose them with the
-  //      corresponding atoms in the residue. Using the superposition
-  //      matrix, add hydrogens to the residue.
-
-  GetMatrixMemory ( D  ,3,3,1,1 );
-  GetMatrixMemory ( U  ,3,3,1,1 );
-  GetMatrixMemory ( V  ,3,3,1,1 );
-  GetVectorMemory ( W  ,3,1 );
-  GetVectorMemory ( RV1,3,1 );
-
-  H  = new PCAtom[natoms];
-  nH = 0;
-
-  for (i=0;i<natoms;i++)  {
-    atomi = atoms.at(i);
-    if ((!strcmp(atomi->element(),"H")) && (A[i]<0) && (nb[i]>0) &&
-        (atomi->x()>-MaxShortReal)) {
-      // ith atom is a hydrogen which is not found in the residue.
-      // Find 3+ core atoms that are most closely bonded to this one.
-      n = c[i][0];  // core atom bonded to the hydrogen
-      if (A[n]>=0)  {
-        sa1[0] = atoms.at(n);
-        sa2[0] = R->atom[A[n]];
-        mm = 1;
-        m  = 1;
-        while ((m<3) && (mm<2))  {
-          k = n;
-          for (j=0;(j<nb[k]) && (m<10);j++)  {
-            n = c[k][j];
-            if (A[n]>=0)  {
-              sa1[m] = atoms.at(n);
-              sa2[m] = R->atom[A[n]];
-              m++;
-            }
-          }
-          mm++;
-        }
-        if (m>=3)  {
-          // superpose atoms and add the hydrogen to the residue
-          k = superpose_atoms ( T,sa1,sa2,m,D,U,V,W,RV1 );
-          if (k==CCP4SRS_Ok)  {
-            H[nH] = atomi->makeCAtom();
-            H[nH]->Transform ( T );
-            nH++;
-          }
+    if (det<=0.0)  {
+      k = 0;
+      B = mmdb::MaxReal;
+      for (j=1;j<=3;j++)
+        if (W[j]<B)  {
+          B = W[j];
+          k = j;
         }
-      }
+      for (j=1;j<=3;j++)
+        V[j][k] = -V[j][k];
     }
-  }
 
-  //  5.  Put hydrogens into the residue
+    //  2.3 Calculate rotational part of T
 
-  for (i=0;i<nH;i++)  {
-    R->InsertAtom ( H[i],nTer );
-    nTer++;
-  }
+    for (j=1;j<=3;j++)
+      for (k=1;k<=3;k++)  {
+        B = 0.0;
+        for (i=1;i<=3;i++)
+          B += U[j][i]*V[k][i];
+        T[j-1][k-1] = B;
+      }
 
+    //  2.4 Add translational part to T
 
-  //  6.  Release memory and return
+    T[0][3] = A2[0]->x - T[0][0]*A1[0]->x() - T[0][1]*A1[0]->y() -
+                         T[0][2]*A1[0]->z();
+    T[1][3] = A2[0]->y - T[1][0]*A1[0]->x() - T[1][1]*A1[0]->y() -
+                         T[1][2]*A1[0]->z();
+    T[2][3] = A2[0]->z - T[2][0]*A1[0]->x() - T[2][1]*A1[0]->y() -
+                         T[2][2]*A1[0]->z();
 
-  if (H)  delete[] H;
-  FreeVectorMemory ( A,0 );
+    return CCP4SRS_Ok;
 
-  FreeVectorMemory ( RV1,1 );
-  FreeVectorMemory ( W  ,1 );
-  FreeMatrixMemory ( V  ,3,1,1 );
-  FreeMatrixMemory ( U  ,3,1,1 );
-  FreeMatrixMemory ( D  ,3,1,1 );
+  }
 
-  FreeVectorMemory ( nb,0 );
-  FreeMatrixMemory ( c ,natoms,0,0 );
+  int Monomer::atom_no ( mmdb::cpstr aname )  {
+  // returns number of atom with given name [0...], or -1 if atom
+  // is not found
+  int i,n;
 
-  return CCP4SRS_Ok;
+    n = -1;
+    for (i=0;(i<atoms.numberOf()) && (n<0);i++)
+      if (!strcmp(atoms.at(i)->name(),aname))
+        n = i;
 
-}
+    return n;
 
+  }
 
-void CCP4SRSMonomer::getAtomNameMatch ( PPCAtom A, int nat,
-                                        pstr altLoc,
-                                        ivector anmatch )  {
-AtomName anamei;
-int      i,j,k, natoms;
-Boolean  done;
+  int Monomer::get_bound ( int atomNo, mmdb::cpstr elem, int serNo ) {
+  // returns number of atom with chemical element 'elem', bound to
+  // atom number 'atomNo' [0,1,..]. serNo==0 returns 1st atom found,
+  // serNo==1 returns second atom and so on. If atom not found, -1 is
+  // returned.
+  int i,j,n, atm1,atm2;
 
-  natoms = atoms.numberOf();
-  for (i=0;i<natoms;i++)  {
-    k    = -1;
-    j    = 0;
-    done = False;
-    while ((j<nat) && (!done))  {
-      if (A[j])  {
-        atoms.at(i)->name_pdb ( anamei );
-        if ((!A[j]->Ter) && (!strcmp(A[j]->name,anamei)))  {
-          k = j;  // atom found
-          // check now for altLocs
-          j++;
-          while ((j<nat) && (!done))  {
-            if (A[j])  {
-              done = (A[j]->Ter || (strcmp(A[j]->name,anamei)));
-              if (!done)  {
-                if (A[j]->occupancy>A[k]->occupancy)  k = j;
-                if (altLoc)  {
-                  if (!strcmp(A[j]->altLoc,altLoc))  {
-                    k    = j;
-                    done = True;
-                  }
-                }
-              }
-            }
-            j++;
-          }
+    n = -1;
+    j = 0;
+    for (i=0;(i<bonds.numberOf()) && (n<0);i++)  {
+      atm2 = bonds.at(i)->atom2();
+      if (atm2==atomNo)  {
+        atm1 = atm2;
+        atm2 = bonds.at(i)->atom1();
+      } else
+        atm1 = bonds.at(i)->atom1();
+      if (atm1==atomNo)  {
+        if (!strcmp(atoms.at(atm2)->element(),elem))  {
+          if (j==serNo)  n = atm2;
+                   else  j++;
         }
       }
-      j++;
     }
-    anmatch[i] = k;
+
+    return n;
+
   }
 
-}
+  int Monomer::get_bound ( int atomNo, int n ) {
+  // returns nth [0,1,..] atom bound to atom with name 'aname'
+  int  i,j,k,atm1,atm2;
+
+    k = -1;
+    j = 0;
+    for (i=0;(i<bonds.numberOf()) && (k<0);i++)  {
+      atm1 = bonds.at(i)->atom1();
+      atm2 = bonds.at(i)->atom2();
+      if (atm1==atomNo)  {
+        if (j==n) k = atm2;
+             else j++;
+      } else if (atm2==atomNo)  {
+        if (j==n) k = atm1;
+             else j++;
+      }
+    }
 
-void CCP4SRSMonomer::getAtomNameMatch ( CCP4SRSContainer<CCP4SRSAtom> *A,
-                                        ivector anmatch )  {
-int i,j,n,nat;
+    return k;
 
-  n   = A->numberOf();
-  nat = atoms.numberOf();
-  for (i=0;i<n;i++)  {
-    anmatch[i] = -1;
-    for (j=0;(j<nat) && (anmatch[i]<0);j++)
-      if (!strcmp(A->at(i)->id(),atoms.at(j)->id()))
-        anmatch[i] = j;
   }
 
-}
+  int Monomer::get_bound ( mmdb::cpstr aname, int n ) {
+  // returns nth [0,1,..] atom bound to atom with name 'aname'
+  int  i,j,k,atm1,atm2;
 
+    k = -1;
+    j = 0;
+    for (i=0;(i<bonds.numberOf()) && (k<0);i++)  {
+      atm1 = bonds.at(i)->atom1();
+      atm2 = bonds.at(i)->atom2();
+      if (!strcmp(atoms.at(atm1)->name(),aname))  {
+        if (j==n) k = atm2;
+             else j++;
+      } else if (!strcmp(atoms.at(atm2)->name(),aname))  {
+        if (j==n) k = atm1;
+             else j++;
+      }
+    }
 
-void CCP4SRSMonomer::readMonIDFromCIF ( PCMMCIFLoop loop )  {
-pstr p;
-int  rc;
-  if (loop && (!monID[0]))  {
-    p  = loop->GetString ( MMCIF_TAG_COMP_ID,0,rc );
-    if (p) strcpy ( monID,p );
-  }
-}
+    return k;
 
-void CCP4SRSMonomer::readMonIDFromCIF ( PCMMCIFStruct mmCIFStruct )  {
-pstr p;
-int  rc;
-  if (mmCIFStruct && (!monID[0]))  {
-    p  = mmCIFStruct->GetString ( MMCIF_TAG_COMP_ID,rc );
-    if (p) strcpy ( monID,p );
   }
-}
 
-// Return code:
-//     CCP4SRS_Ok    success
-int CCP4SRSMonomer::readFromCIF ( PCMMCIFData mmCIFData,
-                                  pstr error_desc )  {
-  reset();
-  if (mmCIFData->GetStructure(MMCIF_STRUCT_CHEM_COMP))
-        return readFromCIF_rcsb ( mmCIFData,error_desc );
-  else  return readFromCIF_ccp4 ( mmCIFData,error_desc );
-}
 
-int CCP4SRSMonomer::readFromCIF_rcsb ( PCMMCIFData mmCIFData,
-                                       pstr error_desc )  {
-PCMMCIFStruct mmCIFStruct;
-PCMMCIFLoop   mmCIFLoop;
-PCCP4SRSAtom  atom;
-PCCP4SRSBond  bond;
-int           rc,loop_len,i;
+  CCP4SRS_RC Monomer::addHydrogens ( mmdb::PResidue R )  {
+  //
+  //   Return:
+  //     _Ok             success
+  //     _EmptyResidue   residue R does not contain atoms
+  //     _NoAtomsFound   monomer does not contain atoms
+  //     _NoBonds        monomer does not contain bonds
+  //     _NoAtomsData    monomer is not complete
+  //     _NoSimilarity   too few coomon atom names in R and SRS
+  //                            entry with the same structure name
+  //     _SuperpositionFailed  failed residue superposition
+  //
+  // NOTE1: the function does not rearranges existing atoms in the
+  // residue, but places the hydrogens on top of them (leaving the
+  // Ter pseudoatom, if found, on top of the list).
+  //
+  // NOTE2: in case of alternative locations, the first one in the
+  // residue is chosen.
+  //
+  mmdb::PPAtom   H;
+  PAtom          sa1[10];
+  PAtom          atomi;
+  mmdb::PAtom    sa2[10];
+  mmdb::AtomName aname;
+  mmdb::rmatrix  D,U,V;
+  mmdb::rvector  W,RV1;
+  mmdb::imatrix  c;
+  mmdb::ivector  A,nb;
+  mmdb::mat44    T;
+  int            natoms,nbonds, i,j,k,m,n,mm,nTer,nH;
+
+    //  1.  Make simple checks first
+
+    natoms = atoms.numberOf();
+    nbonds = bonds.numberOf();
+
+    if (natoms<=2)          return CCP4SRS_NoAtomsFound;
+    if (nbonds<=0)          return CCP4SRS_NoBonds;
+    if (R->nAtoms<=2)       return CCP4SRS_EmptyResidue;
+    if (natoms==R->nAtoms)  return CCP4SRS_Ok;
+
+
+    //  2.  Map existing atoms from the residue onto a local array
+
+    mmdb::GetVectorMemory ( A,natoms,0 );
+    nTer = 20000;
+    for (i=0;i<natoms;i++)  {
+      A[i] = -1;  // signal "no atom"
+      for (j=0;(j<R->nAtoms) && (A[i]<0);j++)
+        if (R->atom[j])  {
+          if (R->atom[j]->Ter)
+            nTer = j;
+          else if (!strcmp(atoms.at(i)->name_pdb(aname),R->atom[j]->name))
+            A[i] = j;  // here is the place to check for altlocs
+        }
+    }
 
-  rc = 0;
 
-  mmCIFStruct = mmCIFData->GetStructure ( MMCIF_STRUCT_CHEM_COMP );
-  if (mmCIFStruct)  {
-    CreateCopy ( monName,mmCIFStruct->GetString(MMCIF_TAG_Name,rc) );
-    CreateCopy ( monType,mmCIFStruct->GetString(MMCIF_TAG_Type,rc) );
-    CreateCopy ( monFormula,mmCIFStruct->GetString(MMCIF_TAG_Formula,
-                                                   rc) );
-  }
+    //  3.  Make bond matrix
 
-  // take atoms
-  mmCIFLoop = mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ATOM );
-  if (!mmCIFLoop)
-    mmCIFStruct = mmCIFData->GetStructure ( MMCIF_LOOP_CHEM_COMP_ATOM );
+    mmdb::GetMatrixMemory ( c ,natoms,10,0,0 );
+    mmdb::GetVectorMemory ( nb,natoms,0 );
 
-  if (mmCIFLoop)  {
+    for (i=0;i<natoms;i++)
+      nb[i] = 0;  // number of bonds at ith atom
 
-    readMonIDFromCIF ( mmCIFLoop );
+    for (i=0;i<nbonds;i++)  {
+      j = bonds.at(i)->atom1();
+      k = bonds.at(i)->atom2();
+      c[j][nb[j]] = k;
+      c[k][nb[k]] = j;
+      nb[j]++;
+      nb[k]++;
+    }
 
-    loop_len = mmCIFLoop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      atom = new CCP4SRSAtom();
-      rc   = atom->readFromCIF_rcsb ( mmCIFLoop,i );
-      if (!rc)  atoms.add ( atom );
-      else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_ATOM );
-        delete atom;
+
+    //  4.  Loop over all hydrogens. Locate core atoms bonded to
+    //      hydrogen in SBStructure and superpose them with the
+    //      corresponding atoms in the residue. Using the superposition
+    //      matrix, add hydrogens to the residue.
+
+    mmdb::GetMatrixMemory ( D  ,3,3,1,1 );
+    mmdb::GetMatrixMemory ( U  ,3,3,1,1 );
+    mmdb::GetMatrixMemory ( V  ,3,3,1,1 );
+    mmdb::GetVectorMemory ( W  ,3,1 );
+    mmdb::GetVectorMemory ( RV1,3,1 );
+
+    H  = new mmdb::PAtom[natoms];
+    nH = 0;
+
+    for (i=0;i<natoms;i++)  {
+      atomi = atoms.at(i);
+      if ((!strcmp(atomi->element(),"H")) && (A[i]<0) && (nb[i]>0) &&
+          (atomi->x()>-mmdb::MaxShortReal)) {
+        // ith atom is a hydrogen which is not found in the residue.
+        // Find 3+ core atoms that are most closely bonded to this one.
+        n = c[i][0];  // core atom bonded to the hydrogen
+        if (A[n]>=0)  {
+          sa1[0] = atoms.at(n);
+          sa2[0] = R->atom[A[n]];
+          mm = 1;
+          m  = 1;
+          while ((m<3) && (mm<2))  {
+            k = n;
+            for (j=0;(j<nb[k]) && (m<10);j++)  {
+              n = c[k][j];
+              if (A[n]>=0)  {
+                sa1[m] = atoms.at(n);
+                sa2[m] = R->atom[A[n]];
+                m++;
+              }
+            }
+            mm++;
+          }
+          if (m>=3)  {
+            // superpose atoms and add the hydrogen to the residue
+            k = superpose_atoms ( T,sa1,sa2,m,D,U,V,W,RV1 );
+            if (k==CCP4SRS_Ok)  {
+              H[nH] = atomi->makeAtom();
+              H[nH]->Transform ( T );
+              nH++;
+            }
+          }
+        }
       }
     }
 
-  } else if (mmCIFStruct)  {
-
-    readMonIDFromCIF ( mmCIFStruct );
+    //  5.  Put hydrogens into the residue
 
-    atom = new CCP4SRSAtom();
-    rc = atom->readFromCIF ( mmCIFStruct );
-    if (!rc)  atoms.add ( atom );
-    else  {
-      if (error_desc)
-        sprintf ( error_desc,"Error %i in %s structure",
-                  rc,MMCIF_LOOP_CHEM_COMP_ATOM );
-      delete atom;
+    for (i=0;i<nH;i++)  {
+      R->InsertAtom ( H[i],nTer );
+      nTer++;
     }
 
-  }
 
-  if (rc)  {
-    reset();
-    return rc;
-  }
+    //  6.  Release memory and return
 
+    if (H)  delete[] H;
+    mmdb::FreeVectorMemory ( A,0 );
 
-  // take bonds
-  mmCIFLoop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_BOND );
-  if (!mmCIFLoop)
-    mmCIFStruct = mmCIFData->GetStructure ( MMCIF_LOOP_CHEM_COMP_BOND );
+    mmdb::FreeVectorMemory ( RV1,1 );
+    mmdb::FreeVectorMemory ( W  ,1 );
+    mmdb::FreeMatrixMemory ( V  ,3,1,1 );
+    mmdb::FreeMatrixMemory ( U  ,3,1,1 );
+    mmdb::FreeMatrixMemory ( D  ,3,1,1 );
 
-  if (mmCIFLoop)  {
+    mmdb::FreeVectorMemory ( nb,0 );
+    mmdb::FreeMatrixMemory ( c ,natoms,0,0 );
 
-    readMonIDFromCIF ( mmCIFLoop );
+    return CCP4SRS_Ok;
 
-    loop_len = mmCIFLoop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      bond = new CCP4SRSBond();
-      rc = bond->readFromCIF_rcsb ( mmCIFLoop,i,atoms );
-      if (!rc)  bonds.add ( bond );
-      else  {
-        if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_BOND );
-        delete bond;
+  }
+
+
+  void Monomer::getAtomNameMatch ( mmdb::PPAtom A, int nat,
+                                          mmdb::pstr    altLoc,
+                                          mmdb::ivector anmatch )  {
+  mmdb::AtomName anamei;
+  int            i,j,k, natoms;
+  bool           done;
+
+    natoms = atoms.numberOf();
+    for (i=0;i<natoms;i++)  {
+      k    = -1;
+      j    = 0;
+      done = false;
+      while ((j<nat) && (!done))  {
+        if (A[j])  {
+          atoms.at(i)->name_pdb ( anamei );
+          if ((!A[j]->Ter) && (!strcmp(A[j]->name,anamei)))  {
+            k = j;  // atom found
+            // check now for altLocs
+            j++;
+            while ((j<nat) && (!done))  {
+              if (A[j])  {
+                done = (A[j]->Ter || (strcmp(A[j]->name,anamei)));
+                if (!done)  {
+                  if (A[j]->occupancy>A[k]->occupancy)  k = j;
+                  if (altLoc)  {
+                    if (!strcmp(A[j]->altLoc,altLoc))  {
+                      k    = j;
+                      done = true;
+                    }
+                  }
+                }
+              }
+              j++;
+            }
+          }
+        }
+        j++;
       }
+      anmatch[i] = k;
     }
 
-  } else if (mmCIFStruct)  {
+  }
 
-    readMonIDFromCIF ( mmCIFStruct );
+  void Monomer::getAtomNameMatch ( Container<Atom> *A,
+                                   mmdb::ivector anmatch )  {
+  int i,j,n,nat;
 
-    bond = new CCP4SRSBond();
-    rc = bond->readFromCIF ( mmCIFStruct,atoms );
-    if (!rc)  bonds.add ( bond );
-    else  {
-      if (error_desc)
-        sprintf ( error_desc,"Error %i in %s structure",
-                  rc,MMCIF_LOOP_CHEM_COMP_BOND );
-      delete bond;
+    n   = A->numberOf();
+    nat = atoms.numberOf();
+    for (i=0;i<n;i++)  {
+      anmatch[i] = -1;
+      for (j=0;(j<nat) && (anmatch[i]<0);j++)
+        if (!strcmp(A->at(i)->id(),atoms.at(j)->id()))
+          anmatch[i] = j;
     }
 
   }
 
-  if (rc)  {
-    reset();
-    return rc;
+
+  void Monomer::readMonIDFromCIF ( mmdb::mmcif::PLoop loop )  {
+  mmdb::pstr p;
+  int        rc;
+    if (loop && (!monID[0]))  {
+      p  = loop->GetString ( MMCIF_TAG_COMP_ID,0,rc );
+      if (p) strcpy ( monID,p );
+    }
+  }
+
+  void Monomer::readMonIDFromCIF ( mmdb::mmcif::PStruct mmCIFStruct )  {
+  mmdb::pstr p;
+  int        rc;
+    if (mmCIFStruct && (!monID[0]))  {
+      p  = mmCIFStruct->GetString ( MMCIF_TAG_COMP_ID,rc );
+      if (p) strcpy ( monID,p );
+    }
   }
 
-  return CCP4SRS_Ok;
+  // Return code:
+  //     _Ok    success
+  int Monomer::readFromCIF ( mmdb::mmcif::PData mmCIFData,
+                                    mmdb::pstr error_desc )  {
+    reset();
+    if (mmCIFData->GetStructure(MMCIF_STRUCT_CHEM_COMP))
+          return readFromCIF_rcsb ( mmCIFData,error_desc );
+    else  return readFromCIF_ccp4 ( mmCIFData,error_desc );
+  }
+
+  int Monomer::readFromCIF_rcsb ( mmdb::mmcif::PData mmCIFData,
+                                         mmdb::pstr error_desc )  {
+  mmdb::mmcif::PStruct mmCIFStruct;
+  mmdb::mmcif::PLoop   mmCIFLoop;
+  PAtom                atom;
+  PBond                bond;
+  int                  rc,loop_len,i;
+
+    rc = 0;
+
+    mmCIFStruct = mmCIFData->GetStructure ( MMCIF_STRUCT_CHEM_COMP );
+    if (mmCIFStruct)  {
+      mmdb::CreateCopy ( monName,mmCIFStruct->GetString(MMCIF_TAG_Name,rc) );
+      mmdb::CreateCopy ( monType,mmCIFStruct->GetString(MMCIF_TAG_Type,rc) );
+      mmdb::CreateCopy ( monFormula,mmCIFStruct->GetString(MMCIF_TAG_Formula,
+                                                     rc) );
+    }
+
+    // take atoms
+    mmCIFLoop = mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ATOM );
+    if (!mmCIFLoop)
+      mmCIFStruct = mmCIFData->GetStructure ( MMCIF_LOOP_CHEM_COMP_ATOM );
+
+    if (mmCIFLoop)  {
+
+      readMonIDFromCIF ( mmCIFLoop );
+
+      loop_len = mmCIFLoop->GetLoopLength();
+      rc       = 0;
+      for (i=0;(i<loop_len) && (!rc);i++)  {
+        atom = new Atom();
+        rc   = atom->readFromCIF_rcsb ( mmCIFLoop,i );
+        if (!rc)  atoms.add ( atom );
+        else  {
+          if (error_desc)
+            sprintf ( error_desc,"Error %i in row %i of %s loop",
+                      rc,i+1,MMCIF_LOOP_CHEM_COMP_ATOM );
+          delete atom;
+        }
+      }
 
-}
+    } else if (mmCIFStruct)  {
 
-int CCP4SRSMonomer::readFromCIF_ccp4 ( PCMMCIFData mmCIFData,
-                                       pstr error_desc )  {
-PCMMCIFLoop       loop;
-PCCP4SRSAtom      atom;
-PCCP4SRSBond      bond;
-PCCP4SRSAngle     angle;
-PCCP4SRSChiCenter chicenter;
-PCCP4SRSTorsion   torsion;
-PCCP4SRSPlane     plane;
-int               loop_len, i,n, rc;
-
-  // take atoms
-  loop =  mmCIFData->GetLoop ( MMCIF_LOOP_CHEM_COMP_ATOM );
-  readMonIDFromCIF ( loop );
-
-  if (loop)  {
-
-    loop_len = loop->GetLoopLength();
-    rc       = 0;
-    for (i=0;(i<loop_len) && (!rc);i++)  {
-      atom = new CCP4SRSAtom();
-      rc = atom->readFromCIF_ccp4 ( loop,i );
+      readMonIDFromCIF ( mmCIFStruct );
+
+      atom = new Atom();
+      rc = atom->readFromCIF ( mmCIFStruct );
       if (!rc)  atoms.add ( atom );
       else  {
         if (error_desc)
-          sprintf ( error_desc,"Error %i in row %i of %s loop",
-                    rc,i+1,MMCIF_LOOP_CHEM_COMP_ATOM );
+          sprintf ( error_desc,"Error %i in %s structure",
+                    rc,MMCIF_LOOP_CHEM_COMP_ATOM );
         delete atom;
       }
+
     }
 
     if (rc)  {
